<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;


class RelEvoVendasService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function buildReportParams($conditions){
        $dateParams = self::buildDateParams($conditions);
        $params = array (
            'CDFILIAL'      => $conditions['CDFILIAL'],
            'DTINI'         => $dateParams['DTINI'],
            'DTFIN'         => $dateParams['DTFIN'],
            'NRORG'         => $conditions['NRORG']
        );
        $params = array(
            'ParametersRow' => $params,
            'ReportName'    => 'EvoVendas'
        );
        return $params;
    }
    
    private function buildDateParams($conditions){
        $thisDate = array(
            'MES' => explode('/', $conditions['DATAINI'])[0],
            'ANO' => explode('/', $conditions['DATAINI'])[1]
        );
        $diaPrimeiroAtual = '01'.'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
        $dataAtual = date('d/m/Y', time());
        if(explode('/', $dataAtual)[1] == $thisDate['MES']){
            $diaFinal = cal_days_in_month (CAL_GREGORIAN, $thisDate['MES'], $thisDate['ANO']);
            $ultimoDiaAtual = $diaFinal.'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
        } else {
            $ultimoDiaAtual = date('t', strtotime(str_replace("/", "-", $diaPrimeiroAtual))).'/'.$thisDate['MES'].'/'.$thisDate['ANO'];
        }
        $dateParams = array(
            'DTINI'       => $diaPrimeiroAtual,
            'DTFIN'       => $ultimoDiaAtual
        );
        return $dateParams;
    }
    
}