<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelProdutosSemNCMAliquotaService {

    public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function find($conditions) {

    $params = array(
        ":TCDFILIAL" => 'F',
        ":CDFILIAL" => $conditions['CDFILIAL']
    );
    return $this->entityManager->getConnection()->fetchAll(self::GET_PROD_WITHOUT_NCM_ALIQUOTA, $params);
  }
  
    const GET_PROD_WITHOUT_NCM_ALIQUOTA = "
        SELECT FI.CDFILIAL||' - '||FI.NMFILIAL AS LABELFILIAL, PR.CDARVPROD||' - '||PR.NMPRODUTO AS LABELPROD, PR.NMPRODUTO, PR.CDARVPROD, 
               CASE WHEN (PE.CDSITUCRT NOT IN(1, 2)) THEN 'NA' ELSE CASE WHEN (AL.CDCSTICMS IN('102', '103', '300', '400', '500', '900')) THEN 'S' ELSE 'N' END END AS CSOSN_ICMS,
               CASE WHEN PE.CDSITUCRT <> 3 THEN 'NA' ELSE CASE WHEN (AL.CDCSTICMS IN('00', '20', '40', '41', '60', '90')) THEN 'S' ELSE 'N' END END AS CST_ICMS,
               CASE WHEN ((PR.CDCLASFISC IS NULL) OR (PR.CDCLASFISC = '')) THEN 'N' ELSE 'S' END AS CDCLASFISC,
               CASE WHEN ((AL.CDCSTICMS IS NULL) OR (AL.CDCSTICMS = '')) THEN 'N' ELSE 'S' END AS CDCSTICMS,
               CASE WHEN ((AL.CDCSTPISCOF IS NULL) OR (AL.CDCSTPISCOF = '')) THEN 'N' ELSE 'S' END AS CDCSTPISCOF,
               CASE WHEN ((AL.CDCFOPPFIS IS NULL) OR (AL.CDCFOPPFIS = '')) THEN 'N' ELSE 'S' END AS CDCFOPPFIS,
               CASE WHEN ((AL.VRALIQPIS IS NULL) OR (AL.VRALIQPIS = '')) THEN 'N' ELSE 'S' END AS VRALIQPIS,
               CASE WHEN ((AL.VRALIQCOFINS IS NULL) OR (AL.VRALIQCOFINS = '')) THEN 'N' ELSE 'S' END AS VRALIQCOFINS
          FROM FILIAL FI, PARAMEMPRESA PE, PRODUTO PR, ALIQIMPFIS AL, ITEMPRECO IT, PARAVEND PA, LOJA L
         WHERE ((INSTR(:CDFILIAL , FI.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
           AND FI.CDFILIAL = IT.CDFILIAL
           AND PR.CDPRODUTO = IT.CDPRODUTO
           AND PE.CDEMPRESA = FI.CDEMPRESA
           AND AL.CDPRODUTO = PR.CDPRODUTO
           AND AL.CDFILIAL = FI.CDFILIAL
           AND FI.CDFILIAL = PA.CDFILIAL
           AND FI.CDFILIAL = L.CDFILIAL
           AND IT.CDTABEPREC = NVL(L.CDTABEPREC, PA.CDTABEPREC)
           AND VRPRECITEM > 0           
           AND ( (PR.CDCLASFISC IS NULL OR PR.CDCLASFISC = '') OR (AL.CDCSTICMS IS NULL OR AL.CDCSTICMS = '') OR (PR.CDCLASFISC IS NULL OR PR.CDCLASFISC = '') OR (AL.CDCSTPISCOF IS NULL OR AL.CDCSTPISCOF = '') 
            OR (AL.CDCFOPPFIS IS NULL OR AL.CDCFOPPFIS = '') OR (AL.VRALIQPIS IS NULL) OR (AL.CDCSTICMS IS NULL OR AL.CDCSTICMS NOT IN('00', '20', '40', '41', '60', '90', '102', '103', '300', '400', '500', '900')))

         UNION

        SELECT FI.CDFILIAL||' - '||FI.NMFILIAL AS LABELFILIAL, PR.CDARVPROD||' - '||PR.NMPRODUTO AS LABELPROD, PR.NMPRODUTO, PR.CDARVPROD,
               CASE WHEN (PE.CDSITUCRT NOT IN(1, 2)) THEN 'NA' ELSE  CASE WHEN (AL.CDCSTICMS IN('102', '103', '300', '400', '500', '900')) THEN 'S' ELSE 'N' END END AS CSOSN_ICMS,
               CASE WHEN PE.CDSITUCRT <> 3 THEN 'NA' ELSE
               CASE WHEN (AL.CDCSTICMS IN('00', '20', '40', '41', '60', '90')) THEN 'S' ELSE 'N' END END AS CST_ICMS,
               CASE WHEN ((PR.CDCLASFISC IS NULL) OR (PR.CDCLASFISC = '')) THEN 'N' ELSE 'S' END AS CDCLASFISC,
               CASE WHEN ((AL.CDCSTICMS IS NULL) OR (AL.CDCSTICMS = '')) THEN 'N' ELSE 'S' END AS CDCSTICMS,
               CASE WHEN ((AL.CDCSTPISCOF IS NULL) OR (AL.CDCSTPISCOF = '')) THEN 'N' ELSE 'S' END AS CDCSTPISCOF,
               CASE WHEN ((AL.CDCFOPPFIS IS NULL) OR (AL.CDCFOPPFIS = '')) THEN 'N' ELSE 'S' END AS CDCFOPPFIS,
               CASE WHEN ((AL.VRALIQPIS IS NULL) OR (AL.VRALIQPIS = '')) THEN 'N' ELSE 'S' END AS VRALIQPIS,
               CASE WHEN ((AL.VRALIQCOFINS IS NULL) OR (AL.VRALIQCOFINS = '')) THEN 'N' ELSE 'S' END AS VRALIQCOFINS
          FROM FILIAL FI, PARAMEMPRESA PE, PRODUTO PR, ALIQIMPFIS AL, ITEMPRECOGER IT ,  FILITABGER FT
         WHERE ((INSTR(:CDFILIAL , FI.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
           AND PR.CDPRODUTO = IT.CDPRODUTO
           AND PR.CDPRODUTO NOT IN (SELECT CDPRODUTO FROM ITEMPRECO  WHERE  ((INSTR(:CDFILIAL , CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T')) AND CDTABEPREC = ( SELECT NVL(L.CDTABEPREC, PA.CDTABEPREC) FROM LOJA L JOIN PARAVEND PA ON L.CDFILIAL = PA.CDFILIAL WHERE ((INSTR(:CDFILIAL , PA.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))))
           AND PE.CDEMPRESA = FI.CDEMPRESA
           AND AL.CDPRODUTO = PR.CDPRODUTO
           AND AL.CDFILIAL = FI.CDFILIAL
           AND FI.CDFILIAL = FT.CDFILIAL
           AND IT.CDTABEPREC = FT.CDTABEPREC
           AND VRPRECITEM > 0
           AND ( (PR.CDCLASFISC IS NULL OR PR.CDCLASFISC = '') OR (AL.CDCSTICMS IS NULL OR AL.CDCSTICMS = '') OR (PR.CDCLASFISC IS NULL OR PR.CDCLASFISC = '') 
            OR (AL.CDCSTPISCOF IS NULL OR AL.CDCSTPISCOF = '') OR (AL.CDCFOPPFIS IS NULL OR AL.CDCFOPPFIS = '') OR (AL.VRALIQPIS IS NULL) 
            OR (AL.CDCSTICMS IS NULL OR AL.CDCSTICMS NOT IN('00', '20', '40', '41', '60', '90', '102', '103', '300', '400', '500', '900')))
            
        UNION
        
        SELECT DISTINCT FI.CDFILIAL||' - '||FI.NMFILIAL AS LABELFILIAL, 
        	   P.CDARVPROD||' - '||P.NMPRODUTO AS LABELPROD, P.NMPRODUTO, P.CDARVPROD,
        	   'N' AS CSOSN_ICMS, 'N' AS CST_ICMS, 
        	   CASE WHEN ((P.CDCLASFISC IS NULL) OR (P.CDCLASFISC = '')) THEN 'N' ELSE 'S' END AS CDCLASFISC, 
        	   'N' AS CDCSTICMS,
        	   'N' AS CDCSTPISCOF, 
        	   'N' AS CDCFOPPFIS, 
        	   'N' AS VRALIQPIS, 
        	   'N' AS VRALIQCOFINS
          FROM PRODUTO P, ITEMPRECO I, FILIAL FI, PARAVEND PA, LOJA L
         WHERE P.CDPRODUTO = I.CDPRODUTO
           AND I.CDFILIAL = FI.CDFILIAL
           AND FI.CDFILIAL = PA.CDFILIAL
           AND FI.CDFILIAL = L.CDFILIAL
           AND I.CDTABEPREC = NVL(L.CDTABEPREC, PA.CDTABEPREC)
           AND VRPRECITEM > 0
           AND ((INSTR(:CDFILIAL , FI.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
           AND P.CDPRODUTO NOT IN (SELECT CDPRODUTO FROM ALIQIMPFIS WHERE ((INSTR(:CDFILIAL , CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T')))
        
        UNION
        
        SELECT DISTINCT FI.CDFILIAL||' - '||FI.NMFILIAL AS LABELFILIAL, 
        	   P.CDARVPROD||' - '||P.NMPRODUTO AS LABELPROD, P.NMPRODUTO, P.CDARVPROD,
        	   'N' AS CSOSN_ICMS, 'N' AS CST_ICMS, 
        	   CASE WHEN ((P.CDCLASFISC IS NULL) OR (P.CDCLASFISC = '')) THEN 'N' ELSE 'S' END AS CDCLASFISC, 
        	   'N' AS CDCSTICMS,
        	   'N' AS CDCSTPISCOF,
        	   'N' AS CDCFOPPFIS, 
        	   'N' AS VRALIQPIS, 
        	   'N' AS VRALIQCOFINS
          FROM PRODUTO P, ITEMPRECOGER G, FILIAL FI, FILITABGER FT
         WHERE P.CDPRODUTO NOT IN (SELECT CDPRODUTO FROM ALIQIMPFIS WHERE ((INSTR(:CDFILIAL , CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T')))
           AND P.CDPRODUTO NOT IN (SELECT CDPRODUTO FROM ITEMPRECO  WHERE  ((INSTR(:CDFILIAL , CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T')) AND CDTABEPREC = ( SELECT NVL(L.CDTABEPREC, PA.CDTABEPREC) FROM LOJA L JOIN PARAVEND PA ON L.CDFILIAL = PA.CDFILIAL WHERE ((INSTR(:CDFILIAL , PA.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))))
           AND P.CDPRODUTO = G.CDPRODUTO
           AND FI.CDFILIAL = FT.CDFILIAL
           AND G.CDTABEPREC = FT.CDTABEPREC
           AND VRPRECITEM > 0
           AND ((INSTR(:CDFILIAL , FT.CDFILIAL ) <> 0) OR (:TCDFILIAL = 'T'))
  ";
}